\documentclass[xcolor=svgnames]{beamer}
\usetheme{Stockton}

\usepackage{epsfig} %for figures
\usepackage{xcolor} %for color
\usepackage[utf8]{inputenc}
\usepackage{multicol}
\usepackage{listings}
\usepackage{textcomp}

%latex definitions:
\def\d{{\rm d}}
\def\half{{\textstyle{1\over2}}}



\title[LFortran\hspace{14em}\insertframenumber/
\inserttotalframenumber]{LFortran: Interactive LLVM-based Fortran Compiler for Modern Architectures}


\author[Čertík, Curcic]{%
Ondřej Čertík\inst{1},
Milan Curcic\inst{2}%
}

\pgfdeclareimage[height=1.5cm]{mylogo}{images/lanl_logo}
\institute{%
Los Alamos National Laboratory\inst{1}\\
University of Miami\inst{2}\\
\vskip0.3cm \pgfuseimage{mylogo}}

\date{September 18, 2020}

\begin{document}

\begin{frame}
\maketitle
\end{frame}

\begin{frame}{Outline}
\begin{itemize}
    \item Background and Motivation
    \item fortran-lang
    \item Demo
    \item Architecture
    \item Current Status
    \item Future Plans
    \item Conclusions
\end{itemize}
\end{frame}

\begin{frame}{Background: Current state of Fortran}
Fortran is a powerful, easy-to-learn language for high-performance computing, however
\begin{itemize}
    \item It lacks modern tooling
    \item Has a poor ecosystem of libraries
    \item Difficult to run on GPUs
    \item Users are disconnected and re-inventing the wheel
\end{itemize}
$\Rightarrow$ User adoption and new Fortran projects are diminishing
\end{frame}

\begin{frame}{Toward a thriving open source Fortran community}
\begin{itemize}
    \item A rich standard library
    \item An easy-to-use, fast package manager and build system
    \item A cutting-edge, fast open source compiler and interpreter for CPUs, GPUs, and emerging architectures
    \item A modern, beautiful website and learning resources to attract new users
    \item A welcoming and inclusive online community
\end{itemize}
$\Rightarrow$ fortran-lang: A young and vibrant online community of Fortran developers
\end{frame}

\begin{frame}{Four pillars of fortran-lang}
\begin{enumerate}
    \item Standard Library (\url{https://github.com/fortran-lang/stdlib})
    \item Package Manager (\url{https://github.com/fortran-lang/fpm})
    \item Compilers -  open source and commercial
    \item Website (\url{https://fortran-lang.org})
\end{enumerate}
\end{frame}

\begin{frame}{Four pillars of fortran-lang (cont.)}
\begin{center}
\includegraphics[width=\textwidth]{images/fortran-lang.pdf}
\end{center}
\end{frame}

\begin{frame}{LFortran: Motivation}
Everything one would expect from modern Fortran:
\begin{itemize}
    \item Cross platform compilation to binaries
    \item Interactivity (like Python)
    \item Nice error messages and warnings
    \item Automatic interoperability with other languages
    \item Translation to other languages
    \item Automatic formatting / language server (VSCode)
    \item Run well on modern architectures (GPU)
    \item Clean design, usable as a library
    \item Static analysis
    \item ...
\end{itemize}
As facilitated by a \textbf{modern compiler}!!
\end{frame}

\begin{frame}
\fontsize{24pt}{15}\selectfont
\begin{center}
    {\bf Demo}
\end{center}
{\fontsize{12pt}{10}\selectfont Webpage: \url{https://lfortran.org}}
\end{frame}

\begin{frame}{Architecture}
\begin{center}
\includegraphics[width=\textwidth]{images/arch.pdf}
\end{center}
\vskip0.3in
AST: Abstract Syntax Tree\\
ASR: Abstract Semantic Representation\\
LLVM: modular and reusable compiler and toolchain technologies
\end{frame}


\begin{frame}{Architecture II}
\begin{itemize}
    \item AST and ASR are standalone independent representations
    \item User tools can target ASR or AST (easy to produce
        semantically correct Fortran code)
    \item ASR allows manipulating Fortran code similar to SymPy
    \item ASR allows rewriting / optimizing of the code (inlining, loop
        optimizations, ...) and showing the end result to the user as Fortran
        code
    \item One can also examine the LLVM code (although less readable than
        Fortran).
    \item Will make the compiler more transparent and helpful to the user
\end{itemize}
\end{frame}

\begin{frame}{Current Status}
Prototype:
\begin{itemize}
    \item Prototype in Python, works interactively on all platforms (Linux,
        macOS, Windows), can compile and run simple programs
    \item Proof of concept validating our ideas
\end{itemize}
Production:
\begin{itemize}
    \item Production version is in C++, surpassed the Python prototype
    \item Works interactively and compiles simple programs with three backends
        (LLVM, C++ and x86)
    \item Very fast compilation
    \item Jupyter notebok kernel (\texttt{lfortran kernel})
    \item Code formatter (\texttt{lfortran fmt})
    \item The parser can parse most of Fortran 2018
\end{itemize}
\end{frame}

\begin{frame}{Future Plans}
Near future
\begin{itemize}
    \item Get first users
    \item Parse all Fortran 2018 syntax to AST (months)
    \item AST to ASR for all of Fortran
    \item Usable LLVM, C++ and x86 backends
\end{itemize}
Down the road:
\begin{itemize}
    \item All the other items from the Motivation
\end{itemize}
\end{frame}



\begin{frame}
\fontsize{24pt}{15}\selectfont
\begin{center}
    {\bf Thank you!}
\end{center}
\end{frame}


\end{document}
